- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# OsiSymSolverInterface Class Reference

OSI Solver Interface for SYMPHONY. More...

`#include <OsiSymSolverInterface.hpp>`

Inheritance diagram for OsiSymSolverInterface:

[legend]
Collaboration diagram for OsiSymSolverInterface:

[legend]
List of all members.

## Public Types
| KEEPCACHED_NONE = 0
| discard all cached data (default)
| KEEPCACHED_COLUMN = 1
| column information: objective values, lower and upper bounds, variable types
| KEEPCACHED_ROW = 2
| row information: right hand sides, ranges and senses, lower and upper bounds for row
| KEEPCACHED_MATRIX = 4
| problem matrix: matrix ordered by column and by row
| KEEPCACHED_RESULTS = 8
| LP solution: primal and dual solution, reduced costs, row activities.
| KEEPCACHED_PROBLEM = KEEPCACHED_COLUMN | KEEPCACHED_ROW | KEEPCACHED_MATRIX
| only discard cached LP solution
| KEEPCACHED_ALL = KEEPCACHED_PROBLEM | KEEPCACHED_RESULTS
| keep all cached data (similar to getMutableLpPtr())
| FREECACHED_COLUMN = KEEPCACHED_PROBLEM & !KEEPCACHED_COLUMN
| free only cached column and LP solution information
| FREECACHED_ROW = KEEPCACHED_PROBLEM & !KEEPCACHED_ROW
| free only cached row and LP solution information
| FREECACHED_MATRIX = KEEPCACHED_PROBLEM & !KEEPCACHED_MATRIX
| free only cached matrix and LP solution information
| FREECACHED_RESULTS = KEEPCACHED_ALL & !KEEPCACHED_RESULTS
| free only cached LP solution information
enum | keepCachedFlag { KEEPCACHED_NONE = 0, KEEPCACHED_COLUMN = 1, KEEPCACHED_ROW = 2, KEEPCACHED_MATRIX = 4, KEEPCACHED_RESULTS = 8, KEEPCACHED_PROBLEM = KEEPCACHED_COLUMN | KEEPCACHED_ROW | KEEPCACHED_MATRIX, KEEPCACHED_ALL = KEEPCACHED_PROBLEM | KEEPCACHED_RESULTS, FREECACHED_COLUMN = KEEPCACHED_PROBLEM & !KEEPCACHED_COLUMN, FREECACHED_ROW = KEEPCACHED_PROBLEM & !KEEPCACHED_ROW, FREECACHED_MATRIX = KEEPCACHED_PROBLEM & !KEEPCACHED_MATRIX, FREECACHED_RESULTS = KEEPCACHED_ALL & !KEEPCACHED_RESULTS }
## Public Member Functions
Solve methods
virtual void | initialSolve ()
| Solve initial LP relaxation.
virtual void | resolve ()
| Resolve an IP problem modification.
virtual void | branchAndBound ()
| Invoke solver's built-in enumeration algorithm.
virtual void | multiCriteriaBranchAndBound ()
| Invoke solver's multi-criteria enumeration algorithm.
virtual double | getLbForNewRhs (int cnt, int *index, double *value)
| Get a lower bound for the new rhs problem using the warm start tree.
virtual double | getUbForNewRhs (int cnt, int *index, double *value)
| Get an upper bound for the new rhs problem using the warm start tree.
virtual double | getUbForNewObj (int cnt, int *index, double *value)
| Solve initial LP relaxation.
Parameter set/get methods
The set methods return true if the parameter was set to the given value, false otherwise. There can be various reasons for failure: the given parameter is not applicable for the solver (e.g., refactorization frequency for the volume algorithm), the parameter is not yet implemented for the solver or simply the value of the parameter is out of the range the solver accepts. If a parameter setting call returns false check the details of your solver. The get methods return true if the given parameter is applicable for the solver and is implemented. In this case the value of the parameter is returned in the second argument. Otherwise they return false.
virtual bool | setIntParam (OsiIntParam key, int value)
virtual bool | setSymParam (OsiSymIntParam key, int value)
virtual bool | setSymParam (const std::string key, int value)
virtual bool | setDblParam (OsiDblParam key, double value)
virtual bool | setSymParam (OsiSymDblParam key, double value)
virtual bool | setSymParam (const std::string key, double value)
virtual bool | setStrParam (OsiStrParam key, const std::string &value)
virtual bool | setSymParam (OsiSymStrParam key, const std::string &value)
virtual bool | setSymParam (const std::string key, const std::string value)
virtual bool | getIntParam (OsiIntParam key, int &value) const
virtual bool | getSymParam (OsiSymIntParam key, int &value) const
virtual bool | getSymParam (const std::string key, int &value) const
virtual bool | getDblParam (OsiDblParam key, double &value) const
virtual bool | getSymParam (OsiSymDblParam key, double &value) const
virtual bool | getSymParam (const std::string key, double &value) const
virtual bool | getStrParam (OsiStrParam key, std::string &value) const
virtual bool | getSymParam (OsiSymStrParam key, std::string &value) const
virtual bool | getSymParam (const std::string key, std::string &value) const
Methods returning info on how the solution process terminated
virtual bool | isAbandoned () const
| Are there numerical difficulties?
virtual bool | isProvenOptimal () const
| Is optimality proven?
virtual bool | isProvenPrimalInfeasible () const
| Is primal infeasiblity proven?
virtual bool | isProvenDualInfeasible () const
| Is dual infeasiblity proven?
virtual bool | isPrimalObjectiveLimitReached () const
| Is the given primal objective limit reached?
virtual bool | isDualObjectiveLimitReached () const
| Is the given dual objective limit reached?
virtual bool | isIterationLimitReached () const
| Iteration limit reached?
virtual bool | isTimeLimitReached () const
| Time limit reached?
virtual bool | isTargetGapReached () const
| Target gap achieved?
Warm start methods
virtual CoinWarmStart * | getEmptyWarmStart () const
| Get an empty warm start object.
virtual CoinWarmStart * | getWarmStart () const
| Get warm start information.
virtual bool | setWarmStart (const CoinWarmStart *warmstart)
| Set warm start information.
Problem query methods
Querying a problem that has no data associated with it will result in zeros for the number of rows and columns, and NULL pointers from the methods that return vectors. Const pointers returned from any data-query method are valid as long as the data is unchanged and the solver is not called.
sym_environment * | getSymphonyEnvironment () const
| Get pointer to SYMPHONY environment (eventually we won't need this).
virtual int | getNumCols () const
| Get number of columns.
virtual int | getNumRows () const
| Get number of rows.
virtual int | getNumElements () const
| Get number of nonzero elements.
virtual const double * | getColLower () const
| Get pointer to array[getNumCols()] of column lower bounds.
virtual const double * | getColUpper () const
| Get pointer to array[getNumCols()] of column upper bounds.
virtual const char * | getRowSense () const
| Get pointer to array[getNumRows()] of row constraint senses.
virtual const double * | getRightHandSide () const
| Get pointer to array[getNumRows()] of row right-hand sides.
virtual const double * | getRowRange () const
| Get pointer to array[getNumRows()] of row ranges.
virtual const double * | getRowLower () const
| Get pointer to array[getNumRows()] of row lower bounds.
virtual const double * | getRowUpper () const
| Get pointer to array[getNumRows()] of row upper bounds.
virtual const double * | getObjCoefficients () const
| Get pointer to array[getNumCols()] of objective function coefficients.
virtual const double * | getObj2Coefficients () const
| Get pointer to array[getNumCols()] of second objective function coefficients if loaded before.
virtual double | getObjSense () const
| Get objective function sense (1 for min (default), -1 for max).
virtual bool | isContinuous (int colIndex) const
| Return true if variable is continuous.
virtual bool | isBinary (int colIndex) const
| Return true if variable is binary.
virtual bool | isInteger (int colIndex) const
| Return true if column is integer.
virtual bool | isIntegerNonBinary (int colIndex) const
| Return true if variable is general integer.
virtual bool | isFreeBinary (int colIndex) const
| Return true if variable is binary and not fixed at either bound.
virtual const CoinPackedMatrix * | getMatrixByRow () const
| Get pointer to row-wise copy of matrix.
virtual const CoinPackedMatrix * | getMatrixByCol () const
| Get pointer to column-wise copy of matrix.
virtual double | getInfinity () const
| Get solver's value for infinity.
Solution query methods
virtual const double * | getColSolution () const
| Get pointer to array[getNumCols()] of primal variable values.
virtual const double * | getRowPrice () const
| Get pointer to array[getNumRows()] of dual variable values.
virtual const double * | getReducedCost () const
| Get a pointer to array[getNumCols()] of reduced costs.
virtual const double * | getRowActivity () const
| Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector).
virtual double | getObjValue () const
| Get objective function value.
virtual double | getPrimalBound () const
| Get the current upper/lower bound.
virtual int | getIterationCount () const
| Get the number of iterations it took to solve the problem (whatever ``iteration'' means to the solver).
virtual std::vector< double * > | getDualRays (int maxNumRays) const
| Get as many dual rays as the solver can provide.
virtual std::vector< double * > | getPrimalRays (int maxNumRays) const
| Get as many primal rays as the solver can provide.
Methods to modify the objective, bounds, and solution
For functions which take a set of indices as parameters (`setObjCoeffSet()`, `setColSetBounds()`, `setRowSetBounds()`, `setRowSetTypes()`), the parameters follow the C++ STL iterator convention: `indexFirst` points to the first index in the set, and `indexLast` points to a position one past the last index in the set.
virtual void | setObjCoeff (int elementIndex, double elementValue)
| Set an objective function coefficient.
virtual void | setObj2Coeff (int elementIndex, double elementValue)
| Set an objective function coefficient for the second objective.
virtual void | setColLower (int elementIndex, double elementValue)
| Set a single column lower bound.
virtual void | setColUpper (int elementIndex, double elementValue)
| Set a single column upper bound.
virtual void | setRowLower (int elementIndex, double elementValue)
| Set a single row lower bound.
virtual void | setRowUpper (int elementIndex, double elementValue)
| Set a single row upper bound.
virtual void | setRowType (int index, char sense, double rightHandSide, double range)
| Set the type of a single row.
virtual void | setObjSense (double s)
| Set the objective function sense.
virtual void | setColSolution (const double *colsol)
| Set the primal solution variable values.
virtual void | setPrimalBound (const double bound)
| Set the a priori upper/lower bound.
virtual void | setRowPrice (const double *rowprice)
| Set dual solution variable values.
Methods to set variable type
virtual void | setContinuous (int index)
| Set the index-th variable to be a continuous variable.
virtual void | setInteger (int index)
| Set the index-th variable to be an integer variable.
virtual void | setColName (char **colname)
| Set the index-th variable to be a continuous variable.
Methods to expand a problem.
Note that new columns are added as continuous variables.
virtual void | addCol (const CoinPackedVectorBase &vec, const double collb, const double colub, const double obj)
| Add a column (primal variable) to the problem.
virtual void | deleteCols (const int num, const int *colIndices)
| Remove a set of columns (primal variables) from the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const double rowlb, const double rowub)
| Add a row (constraint) to the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const char rowsen, const double rowrhs, const double rowrng)
| Add a column (primal variable) to the problem.
virtual void | deleteRows (const int num, const int *rowIndices)
| Delete a set of rows (constraints) from the problem.
Methods to input a problem
virtual void | loadProblem ()
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, double *&rowlb, double *&rowub)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, char *&rowsen, double *&rowrhs, double *&rowrng)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).
virtual void | loadProblem (const int numcols, const int numrows, const CoinBigIndex *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).
virtual void | loadProblem (const int numcols, const int numrows, const CoinBigIndex *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).
virtual void | writeMps (const char *filename, const char *extension="mps", double objSense=0.0) const
| Write the problem in MPS format to the specified file.
void | parseCommandLine (int argc, char **argv)
virtual int | readMps (const char *infile, const char *extension="mps")
| Read a problem in MPS format from the given filename.
virtual int | readGMPL (const char *modelFile, const char *dataFile=NULL)
| Read a problem in GMPL format from the given filenames.
void | findInitialBounds ()
int | createPermanentCutPools ()
Constructors and destructors
| OsiSymSolverInterface ()
| Default Constructor.
virtual OsiSolverInterface * | clone (bool copyData=true) const
| Clone.
| OsiSymSolverInterface (const OsiSymSolverInterface &)
| Copy constructor.
OsiSymSolverInterface & | operator= (const OsiSymSolverInterface &rhs)
| Assignment operator.
virtual | ~OsiSymSolverInterface ()
| Destructor.
virtual void | reset ()
| Reset the solver interface.
## Protected Member Functions
Protected methods
virtual void | applyRowCut (const OsiRowCut &rc)
| Apply a row cut (append to the constraint matrix).
virtual void | applyColCut (const OsiColCut &cc)
| Apply a column cut (adjust the bounds of one or more variables).
void | setInitialData ()
| Set OsiSolverInterface object state for default constructor.
## Private Member Functions
void | gutsOfConstructor ()
| The real work of the constructor.
void | gutsOfDestructor ()
| The real work of the destructor.
void | freeCachedColRim ()
| free cached column rim vectors
void | freeCachedRowRim ()
| free cached row rim vectors
void | freeCachedResults ()
| free cached result vectors
void | freeCachedMatrix ()
| free cached matrices
void | freeCachedData (int keepCached=KEEPCACHED_NONE)
| free all cached data (except specified entries, see getLpPtr())
void | freeAllMemory ()
| free all allocated memory
void | printBounds ()
| Just for testing purposes.
## Private Attributes
double * | obj_
| Pointer to objective vector.
double * | obj2_
| Pointer to second objective vector to be used in bicriteria solver.
double * | collower_
| Pointer to dense vector of variable lower bounds.
double * | colupper_
| Pointer to dense vector of variable lower bounds.
char * | rowsense_
| Pointer to dense vector of row sense indicators.
double * | rhs_
| Pointer to dense vector of row right-hand side values.
double * | rowrange_
| Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows).
double * | rowlower_
| Pointer to dense vector of row lower bounds.
double * | rowupper_
| Pointer to dense vector of row upper bounds.
double * | colsol_
| Pointer to primal solution vector.
double * | rowact_
| Pointer to row activity (slack) vector.
CoinPackedMatrix * | matrixByRow_
| Pointer to row-wise copy of problem matrix coefficients.
CoinPackedMatrix * | matrixByCol_
| Pointer to row-wise copy of problem matrix coefficients.
Private member data
sym_environment * | env_
| The pointer to the SYMPHONY problem environment.
## Friends
int | OsiSymSolverInterfaceUnitTest (const std::string &mpsDir, const std::string &netlibDir)
| A function that tests the methods in the OsiSymSolverInterface class.

## Detailed Description

OSI Solver Interface for SYMPHONY.

Many OsiSolverInterface query methods return a const pointer to the requested read-only data. If the model data is changed or the solver is called, these pointers may no longer be valid and should be refreshed by invoking the member function to obtain an updated copy of the pointer. For example:

          OsiSolverInterface solverInterfacePtr ;
          const double * ruBnds = solverInterfacePtr->getRowUpper();
          solverInterfacePtr->applyCuts(someSetOfCuts);
          // ruBnds is no longer a valid pointer and must be refreshed
          ruBnds = solverInterfacePtr->getRowUpper();

Querying a problem that has no data associated with it will result in zeros for the number of rows and columns, and NULL pointers from the methods that return vectors.

Definition at line 57 of file OsiSymSolverInterface.hpp.

## Member Enumeration Documentation

enum OsiSymSolverInterface::keepCachedFlag

Enumerator:

  KEEPCACHED_NONE | discard all cached data (default)
  KEEPCACHED_COLUMN | column information: objective values, lower and upper bounds, variable types
  KEEPCACHED_ROW | row information: right hand sides, ranges and senses, lower and upper bounds for row
  KEEPCACHED_MATRIX | problem matrix: matrix ordered by column and by row
  KEEPCACHED_RESULTS | LP solution: primal and dual solution, reduced costs, row activities.
  KEEPCACHED_PROBLEM | only discard cached LP solution
  KEEPCACHED_ALL | keep all cached data (similar to getMutableLpPtr())
  FREECACHED_COLUMN | free only cached column and LP solution information
  FREECACHED_ROW | free only cached row and LP solution information
  FREECACHED_MATRIX | free only cached matrix and LP solution information
  FREECACHED_RESULTS | free only cached LP solution information

Definition at line 659 of file OsiSymSolverInterface.hpp.

## Constructor & Destructor Documentation

OsiSymSolverInterface::OsiSymSolverInterface | ( |  | ) |

Default Constructor.

OsiSymSolverInterface::OsiSymSolverInterface | ( | const OsiSymSolverInterface & |  | ) |

Copy constructor.

virtual OsiSymSolverInterface::~OsiSymSolverInterface | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual void OsiSymSolverInterface::initialSolve | ( |  | ) | `[virtual]`

Solve initial LP relaxation.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::resolve | ( |  | ) | `[virtual]`

Resolve an IP problem modification.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::branchAndBound | ( |  | ) | `[virtual]`

Invoke solver's built-in enumeration algorithm.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::multiCriteriaBranchAndBound | ( |  | ) | `[virtual]`

Invoke solver's multi-criteria enumeration algorithm.

virtual double OsiSymSolverInterface::getLbForNewRhs | ( | int | cnt,
|  | int * | index,
|  | double * | value |
| ) |  |  | `[virtual]`

Get a lower bound for the new rhs problem using the warm start tree.

virtual double OsiSymSolverInterface::getUbForNewRhs | ( | int | cnt,
|  | int * | index,
|  | double * | value |
| ) |  |  | `[virtual]`

Get an upper bound for the new rhs problem using the warm start tree.

virtual double OsiSymSolverInterface::getUbForNewObj | ( | int | cnt,
|  | int * | index,
|  | double * | value |
| ) |  |  | `[virtual]`

Solve initial LP relaxation.

virtual bool OsiSymSolverInterface::setIntParam | ( | OsiIntParam | key,
|  | int | value |
| ) |  |  | `[virtual]`

Reimplemented from OsiSolverInterface.

virtual bool OsiSymSolverInterface::setSymParam | ( | OsiSymIntParam | key,
|  | int | value |
| ) |  |  | `[virtual]`

virtual bool OsiSymSolverInterface::setSymParam | ( | const std::string | key,
|  | int | value |
| ) |  |  | `[virtual]`

virtual bool OsiSymSolverInterface::setDblParam | ( | OsiDblParam | key,
|  | double | value |
| ) |  |  | `[virtual]`

Reimplemented from OsiSolverInterface.

virtual bool OsiSymSolverInterface::setSymParam | ( | OsiSymDblParam | key,
|  | double | value |
| ) |  |  | `[virtual]`

virtual bool OsiSymSolverInterface::setSymParam | ( | const std::string | key,
|  | double | value |
| ) |  |  | `[virtual]`

virtual bool OsiSymSolverInterface::setStrParam | ( | OsiStrParam | key,
|  | const std::string & | value |
| ) |  |  | `[virtual]`

Reimplemented from OsiSolverInterface.

virtual bool OsiSymSolverInterface::setSymParam | ( | OsiSymStrParam | key,
|  | const std::string & | value |
| ) |  |  | `[virtual]`

virtual bool OsiSymSolverInterface::setSymParam | ( | const std::string | key,
|  | const std::string | value |
| ) |  |  | `[virtual]`

virtual bool OsiSymSolverInterface::getIntParam | ( | OsiIntParam | key,
|  | int & | value |
| ) |  |  | const`[virtual]`

Reimplemented from OsiSolverInterface.

virtual bool OsiSymSolverInterface::getSymParam | ( | OsiSymIntParam | key,
|  | int & | value |
| ) |  |  | const`[virtual]`

virtual bool OsiSymSolverInterface::getSymParam | ( | const std::string | key,
|  | int & | value |
| ) |  |  | const`[virtual]`

virtual bool OsiSymSolverInterface::getDblParam | ( | OsiDblParam | key,
|  | double & | value |
| ) |  |  | const`[virtual]`

Reimplemented from OsiSolverInterface.

virtual bool OsiSymSolverInterface::getSymParam | ( | OsiSymDblParam | key,
|  | double & | value |
| ) |  |  | const`[virtual]`

virtual bool OsiSymSolverInterface::getSymParam | ( | const std::string | key,
|  | double & | value |
| ) |  |  | const`[virtual]`

virtual bool OsiSymSolverInterface::getStrParam | ( | OsiStrParam | key,
|  | std::string & | value |
| ) |  |  | const`[virtual]`

Reimplemented from OsiSolverInterface.

virtual bool OsiSymSolverInterface::getSymParam | ( | OsiSymStrParam | key,
|  | std::string & | value |
| ) |  |  | const`[virtual]`

virtual bool OsiSymSolverInterface::getSymParam | ( | const std::string | key,
|  | std::string & | value |
| ) |  |  | const`[virtual]`

virtual bool OsiSymSolverInterface::isAbandoned | ( |  | ) | const`[virtual]`

Are there numerical difficulties?

Implements OsiSolverInterface.

virtual bool OsiSymSolverInterface::isProvenOptimal | ( |  | ) | const`[virtual]`

Is optimality proven?

Implements OsiSolverInterface.

virtual bool OsiSymSolverInterface::isProvenPrimalInfeasible | ( |  | ) | const`[virtual]`

Is primal infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiSymSolverInterface::isProvenDualInfeasible | ( |  | ) | const`[inline, virtual]`

Is dual infeasiblity proven?

Implements OsiSolverInterface.

Definition at line 186 of file OsiSymSolverInterface.hpp.

virtual bool OsiSymSolverInterface::isPrimalObjectiveLimitReached | ( |  | ) | const`[virtual]`

Is the given primal objective limit reached?

Implements OsiSolverInterface.

virtual bool OsiSymSolverInterface::isDualObjectiveLimitReached | ( |  | ) | const`[inline, virtual]`

Is the given dual objective limit reached?

Implements OsiSolverInterface.

Definition at line 194 of file OsiSymSolverInterface.hpp.

virtual bool OsiSymSolverInterface::isIterationLimitReached | ( |  | ) | const`[virtual]`

Iteration limit reached?

Implements OsiSolverInterface.

virtual bool OsiSymSolverInterface::isTimeLimitReached | ( |  | ) | const`[virtual]`

Time limit reached?

virtual bool OsiSymSolverInterface::isTargetGapReached | ( |  | ) | const`[virtual]`

Target gap achieved?

virtual CoinWarmStart* OsiSymSolverInterface::getEmptyWarmStart | ( |  | ) | const`[inline, virtual]`

Get an empty warm start object.

This routine returns an empty warm start object. Its purpose is to provide a way to give a client a warm start object of the appropriate type, which can resized and modified as desired.

Implements OsiSolverInterface.

Definition at line 219 of file OsiSymSolverInterface.hpp.

virtual CoinWarmStart* OsiSymSolverInterface::getWarmStart | ( |  | ) | const`[virtual]`

Get warm start information.

If there is no valid solution, an empty warm start object (0 rows, 0 columns) wil be returned.

Implements OsiSolverInterface.

virtual bool OsiSymSolverInterface::setWarmStart | ( | const CoinWarmStart * | warmstart | ) | `[virtual]`

Set warm start information.

Return true/false depending on whether the warm start information was accepted or not.

Implements OsiSolverInterface.

sym_environment* OsiSymSolverInterface::getSymphonyEnvironment | ( |  | ) | const`[inline]`

Get pointer to SYMPHONY environment (eventually we won't need this).

Definition at line 255 of file OsiSymSolverInterface.hpp.

References env_.

virtual int OsiSymSolverInterface::getNumCols | ( |  | ) | const`[virtual]`

Get number of columns.

Implements OsiSolverInterface.

virtual int OsiSymSolverInterface::getNumRows | ( |  | ) | const`[virtual]`

Get number of rows.

Implements OsiSolverInterface.

virtual int OsiSymSolverInterface::getNumElements | ( |  | ) | const`[virtual]`

Get number of nonzero elements.

Implements OsiSolverInterface.

virtual const double* OsiSymSolverInterface::getColLower | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of column lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiSymSolverInterface::getColUpper | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of column upper bounds.

Implements OsiSolverInterface.

virtual const char* OsiSymSolverInterface::getRowSense | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row constraint senses.

- 'L': <= constraint
- 'E': = constraint
- 'G': >= constraint
- 'R': ranged constraint
- 'N': free constraint

Implements OsiSolverInterface.

virtual const double* OsiSymSolverInterface::getRightHandSide | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row right-hand sides.

- if getRowSense()[i] == 'L' then getRightHandSide()[i] == getRowUpper()[i]
- if getRowSense()[i] == 'G' then getRightHandSide()[i] == getRowLower()[i]
- if getRowSense()[i] == 'R' then getRightHandSide()[i] == getRowUpper()[i]
- if getRowSense()[i] == 'N' then getRightHandSide()[i] == 0.0

Implements OsiSolverInterface.

virtual const double* OsiSymSolverInterface::getRowRange | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row ranges.

- if getRowSense()[i] == 'R' then getRowRange()[i] == getRowUpper()[i] - getRowLower()[i]
- if getRowSense()[i] != 'R' then getRowRange()[i] is 0.0

Implements OsiSolverInterface.

virtual const double* OsiSymSolverInterface::getRowLower | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiSymSolverInterface::getRowUpper | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row upper bounds.

Implements OsiSolverInterface.

virtual const double* OsiSymSolverInterface::getObjCoefficients | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of objective function coefficients.

Implements OsiSolverInterface.

virtual const double* OsiSymSolverInterface::getObj2Coefficients | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of second objective function coefficients if loaded before.

virtual double OsiSymSolverInterface::getObjSense | ( |  | ) | const`[virtual]`

Get objective function sense (1 for min (default), -1 for max).

Implements OsiSolverInterface.

virtual bool OsiSymSolverInterface::isContinuous | ( | int | colIndex | ) | const`[virtual]`

Return true if variable is continuous.

Implements OsiSolverInterface.

virtual bool OsiSymSolverInterface::isBinary | ( | int | colIndex | ) | const`[virtual]`

Return true if variable is binary.

Reimplemented from OsiSolverInterface.

virtual bool OsiSymSolverInterface::isInteger | ( | int | colIndex | ) | const`[virtual]`

Return true if column is integer.

Note: This function returns true if the the column is binary or a general integer.

Reimplemented from OsiSolverInterface.

virtual bool OsiSymSolverInterface::isIntegerNonBinary | ( | int | colIndex | ) | const`[virtual]`

Return true if variable is general integer.

Reimplemented from OsiSolverInterface.

virtual bool OsiSymSolverInterface::isFreeBinary | ( | int | colIndex | ) | const`[virtual]`

Return true if variable is binary and not fixed at either bound.

Reimplemented from OsiSolverInterface.

virtual const CoinPackedMatrix* OsiSymSolverInterface::getMatrixByRow | ( |  | ) | const`[virtual]`

Get pointer to row-wise copy of matrix.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiSymSolverInterface::getMatrixByCol | ( |  | ) | const`[virtual]`

Get pointer to column-wise copy of matrix.

Implements OsiSolverInterface.

virtual double OsiSymSolverInterface::getInfinity | ( |  | ) | const`[virtual]`

Get solver's value for infinity.

Implements OsiSolverInterface.

virtual const double* OsiSymSolverInterface::getColSolution | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of primal variable values.

Implements OsiSolverInterface.

virtual const double* OsiSymSolverInterface::getRowPrice | ( |  | ) | const`[inline, virtual]`

Get pointer to array[getNumRows()] of dual variable values.

Implements OsiSolverInterface.

Definition at line 359 of file OsiSymSolverInterface.hpp.

virtual const double* OsiSymSolverInterface::getReducedCost | ( |  | ) | const`[inline, virtual]`

Get a pointer to array[getNumCols()] of reduced costs.

Implements OsiSolverInterface.

Definition at line 366 of file OsiSymSolverInterface.hpp.

virtual const double* OsiSymSolverInterface::getRowActivity | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector).

Implements OsiSolverInterface.

virtual double OsiSymSolverInterface::getObjValue | ( |  | ) | const`[virtual]`

Get objective function value.

Implements OsiSolverInterface.

virtual double OsiSymSolverInterface::getPrimalBound | ( |  | ) | const`[virtual]`

Get the current upper/lower bound.

virtual int OsiSymSolverInterface::getIterationCount | ( |  | ) | const`[virtual]`

Get the number of iterations it took to solve the problem (whatever ``iteration'' means to the solver).

Implements OsiSolverInterface.

virtual std::vector<double*> OsiSymSolverInterface::getDualRays | ( | int | maxNumRays | ) | const`[inline, virtual]`

Get as many dual rays as the solver can provide.

In case of proven primal infeasibility there should be at least one.

Note:
  Implementors of solver interfaces note that the double pointers in the vector should point to arrays of length getNumRows() and they should be allocated via new[].

  Clients of solver interfaces note that it is the client's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

Definition at line 399 of file OsiSymSolverInterface.hpp.

virtual std::vector<double*> OsiSymSolverInterface::getPrimalRays | ( | int | maxNumRays | ) | const`[inline, virtual]`

Get as many primal rays as the solver can provide.

(In case of proven dual infeasibility there should be at least one.)

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumCols() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

Definition at line 414 of file OsiSymSolverInterface.hpp.

virtual void OsiSymSolverInterface::setObjCoeff | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set an objective function coefficient.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::setObj2Coeff | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set an objective function coefficient for the second objective.

virtual void OsiSymSolverInterface::setColLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single column lower bound.

Use -getInfinity() for -infinity.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::setColUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single column upper bound.

Use getInfinity() for infinity.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::setRowLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single row lower bound.

Use -getInfinity() for -infinity.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::setRowUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single row upper bound.

Use getInfinity() for infinity.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::setRowType | ( | int | index,
|  | char | sense,
|  | double | rightHandSide,
|  | double | range |
| ) |  |  | `[virtual]`

Set the type of a single row.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::setObjSense | ( | double | s | ) | `[virtual]`

Set the objective function sense.

(1 for min (default), -1 for max)

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::setColSolution | ( | const double * | colsol | ) | `[virtual]`

Set the primal solution variable values.

colsol[getNumCols()] is an array of values for the primal variables. These values are copied to memory owned by the solver interface object or the solver. They will be returned as the result of getColSolution() until changed by another call to setColSolution() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::setPrimalBound | ( | const double | bound | ) | `[virtual]`

Set the a priori upper/lower bound.

virtual void OsiSymSolverInterface::setRowPrice | ( | const double * | rowprice | ) | `[inline, virtual]`

Set dual solution variable values.

rowprice[getNumRows()] is an array of values for the dual variables. These values are copied to memory owned by the solver interface object or the solver. They will be returned as the result of getRowPrice() until changed by another call to setRowPrice() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

Definition at line 490 of file OsiSymSolverInterface.hpp.

virtual void OsiSymSolverInterface::setContinuous | ( | int | index | ) | `[virtual]`

Set the index-th variable to be a continuous variable.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::setInteger | ( | int | index | ) | `[virtual]`

Set the index-th variable to be an integer variable.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::setColName | ( | char ** | colname | ) | `[virtual]`

Set the index-th variable to be a continuous variable.

virtual void OsiSymSolverInterface::addCol | ( | const CoinPackedVectorBase & | vec,
|  | const double | collb,
|  | const double | colub,
|  | const double | obj |
| ) |  |  | `[virtual]`

Add a column (primal variable) to the problem.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::deleteCols | ( | const int | num,
|  | const int * | colIndices |
| ) |  |  | `[virtual]`

Remove a set of columns (primal variables) from the problem.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const double | rowlb,
|  | const double | rowub |
| ) |  |  | `[virtual]`

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const char | rowsen,
|  | const double | rowrhs,
|  | const double | rowrng |
| ) |  |  | `[virtual]`

Add a column (primal variable) to the problem.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::deleteRows | ( | const int | num,
|  | const int * | rowIndices |
| ) |  |  | `[virtual]`

Delete a set of rows (constraints) from the problem.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::loadProblem | ( |  | ) | `[virtual]`

virtual void OsiSymSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `rowub`: all rows have upper bound infinity
- `rowlb`: all rows have lower bound -infinity
- `obj`: all variables have 0 objective coefficient

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | double *& | rowlb,
|  | double *& | rowub |
| ) |  |  | `[virtual]`

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).

For default values see the previous method.

Warning:
  The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `obj`: all variables have 0 objective coefficient
- `rowsen`: all rows are >=
- `rowrhs`: all right hand sides are 0
- `rowrng`: 0 for the ranged rows

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | char *& | rowsen,
|  | double *& | rowrhs,
|  | double *& | rowrng |
| ) |  |  | `[virtual]`

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).

For default values see the previous method.

Warning:
  The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const CoinBigIndex * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const CoinBigIndex * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::writeMps | ( | const char * | filename,
|  | const char * | extension = `"mps"`,
|  | double | objSense = `0.0` |
| ) |  |  | const`[virtual]`

Write the problem in MPS format to the specified file.

If objSense is non-zero, a value of -1.0 causes the problem to be written with a maximization objective; +1.0 forces a minimization objective. If objSense is zero, the choice is left to implementation.

Implements OsiSolverInterface.

void OsiSymSolverInterface::parseCommandLine | ( | int | argc,
|  | char ** | argv |
| ) |  |  |

virtual int OsiSymSolverInterface::readMps | ( | const char * | infile,
|  | const char * | extension = `"mps"` |
| ) |  |  | `[virtual]`

Read a problem in MPS format from the given filename.

The default implementation uses CoinMpsIO::readMps() to read the MPS file and returns the number of errors encountered.

Reimplemented from OsiSolverInterface.

virtual int OsiSymSolverInterface::readGMPL | ( | const char * | modelFile,
|  | const char * | dataFile = `NULL` |
| ) |  |  | `[virtual]`

Read a problem in GMPL format from the given filenames.

The default implementation uses CoinMpsIO::readGMPL(). This capability is available only if the third-party package Glpk is installed.

Reimplemented from OsiSolverInterface.

void OsiSymSolverInterface::findInitialBounds | ( |  | ) |

int OsiSymSolverInterface::createPermanentCutPools | ( |  | ) |

virtual OsiSolverInterface* OsiSymSolverInterface::clone | ( | bool | copyData = `true` | ) | const`[virtual]`

Clone.

The result of calling clone(false) is defined to be equivalent to calling the default constructor OsiSolverInterface().

Implements OsiSolverInterface.

OsiSymSolverInterface& OsiSymSolverInterface::operator= | ( | const OsiSymSolverInterface & | rhs | ) |

Assignment operator.

virtual void OsiSymSolverInterface::reset | ( |  | ) | `[virtual]`

Reset the solver interface.

A call to reset() returns the solver interface to the same state as it would have if it had just been constructed by calling the default constructor OsiSolverInterface().

Reimplemented from OsiSolverInterface.

virtual void OsiSymSolverInterface::applyRowCut | ( | const OsiRowCut & | rc | ) | `[protected, virtual]`

Apply a row cut (append to the constraint matrix).

Implements OsiSolverInterface.

virtual void OsiSymSolverInterface::applyColCut | ( | const OsiColCut & | cc | ) | `[protected, virtual]`

Apply a column cut (adjust the bounds of one or more variables).

Implements OsiSolverInterface.

void OsiSymSolverInterface::setInitialData | ( |  | ) | `[protected]`

Set OsiSolverInterface object state for default constructor.

This routine establishes the initial values of data fields in the OsiSolverInterface object when the object is created using the default constructor.

Reimplemented from OsiSolverInterface.

void OsiSymSolverInterface::gutsOfConstructor | ( |  | ) | `[private]`

The real work of the constructor.

void OsiSymSolverInterface::gutsOfDestructor | ( |  | ) | `[private]`

The real work of the destructor.

void OsiSymSolverInterface::freeCachedColRim | ( |  | ) | `[private]`

free cached column rim vectors

void OsiSymSolverInterface::freeCachedRowRim | ( |  | ) | `[private]`

free cached row rim vectors

void OsiSymSolverInterface::freeCachedResults | ( |  | ) | `[private]`

free cached result vectors

void OsiSymSolverInterface::freeCachedMatrix | ( |  | ) | `[private]`

free cached matrices

void OsiSymSolverInterface::freeCachedData | ( | int | keepCached = `KEEPCACHED_NONE` | ) | `[private]`

free all cached data (except specified entries, see getLpPtr())

void OsiSymSolverInterface::freeAllMemory | ( |  | ) | `[private]`

free all allocated memory

void OsiSymSolverInterface::printBounds | ( |  | ) | `[private]`

Just for testing purposes.

## Friends And Related Function Documentation

int OsiSymSolverInterfaceUnitTest | ( | const std::string & | mpsDir,
|  | const std::string & | netlibDir |
| ) |  |  | `[friend]`

A function that tests the methods in the OsiSymSolverInterface class.

The only reason for it not to be a member method is that this way it doesn't have to be compiled into the library. And that's a gain, because the library should be compiled with optimization on, but this method should be compiled with debugging.

## Member Data Documentation

sym_environment* OsiSymSolverInterface::env_`[private]`

The pointer to the SYMPHONY problem environment.

Definition at line 767 of file OsiSymSolverInterface.hpp.

Referenced by getSymphonyEnvironment().

double* OsiSymSolverInterface::obj_`[mutable, private]`

Pointer to objective vector.

Definition at line 771 of file OsiSymSolverInterface.hpp.

double* OsiSymSolverInterface::obj2_`[mutable, private]`

Pointer to second objective vector to be used in bicriteria solver.

Definition at line 774 of file OsiSymSolverInterface.hpp.

double* OsiSymSolverInterface::collower_`[mutable, private]`

Pointer to dense vector of variable lower bounds.

Definition at line 777 of file OsiSymSolverInterface.hpp.

double* OsiSymSolverInterface::colupper_`[mutable, private]`

Pointer to dense vector of variable lower bounds.

Definition at line 780 of file OsiSymSolverInterface.hpp.

char* OsiSymSolverInterface::rowsense_`[mutable, private]`

Pointer to dense vector of row sense indicators.

Definition at line 783 of file OsiSymSolverInterface.hpp.

double* OsiSymSolverInterface::rhs_`[mutable, private]`

Pointer to dense vector of row right-hand side values.

Definition at line 786 of file OsiSymSolverInterface.hpp.

double* OsiSymSolverInterface::rowrange_`[mutable, private]`

Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows).

Definition at line 791 of file OsiSymSolverInterface.hpp.

double* OsiSymSolverInterface::rowlower_`[mutable, private]`

Pointer to dense vector of row lower bounds.

Definition at line 794 of file OsiSymSolverInterface.hpp.

double* OsiSymSolverInterface::rowupper_`[mutable, private]`

Pointer to dense vector of row upper bounds.

Definition at line 797 of file OsiSymSolverInterface.hpp.

double* OsiSymSolverInterface::colsol_`[mutable, private]`

Pointer to primal solution vector.

Definition at line 800 of file OsiSymSolverInterface.hpp.

double* OsiSymSolverInterface::rowact_`[mutable, private]`

Pointer to row activity (slack) vector.

Definition at line 803 of file OsiSymSolverInterface.hpp.

CoinPackedMatrix* OsiSymSolverInterface::matrixByRow_`[mutable, private]`

Pointer to row-wise copy of problem matrix coefficients.

Definition at line 806 of file OsiSymSolverInterface.hpp.

CoinPackedMatrix* OsiSymSolverInterface::matrixByCol_`[mutable, private]`

Pointer to row-wise copy of problem matrix coefficients.

Definition at line 809 of file OsiSymSolverInterface.hpp.

The documentation for this class was generated from the following file:

- /home/coin/SVN-release/Cgl-0.53.1/Osi/src/OsiSym/OsiSymSolverInterface.hpp